package agentrouble;

import java.util.*;

public class Inscritor {
	Map objetos;
	Map cruzadas;
	Map referencias;

	public Inscritor() {
		objetos = new TreeMap();
		referencias = new TreeMap();
		cruzadas = new TreeMap();
	}
	

	public void inscreve(Object c, Object d) {
		Collection aux = (Collection)objetos.get(c);
		if (aux == null)
			aux = new TreeSet();
		aux.add(d);

		objetos.put(c, aux);
		referencias.put(d, new Boolean(false));
		cruzadas.put(d, aux);
	}

	public void remove(Object d) {
		Collection aux = (Collection)cruzadas.get(d);
		aux.remove(d);
	}

	public Object requer(Object c) {
		Collection aux = (Collection)objetos.get(c);

		for (Iterator i = aux.iterator(); i.hasNext();) {

			Object d = (Object)i.next();
			Boolean b = (Boolean)referencias.get(d);
			if (!b.booleanValue()) {
				referencias.put(d, new Boolean(true));
				return d;
			}
		}

		return null;
			
	}

	public void libera(Object d) {
		referencias.put(d, new Boolean(false));
	}

	public String toString() {
		String s = "Inscritor: {\n";

		
		for (Iterator i = objetos.keySet().iterator(); i.hasNext();) {
			Object c = (Object)i.next();

			s += c + " => {";
			
			for (Iterator j = ((Collection)objetos.get(c)).iterator(); j.hasNext();) {
				Object d = (Object)j.next();
				s += d + "; ";
			}
			s += "};\n";
		}
		s += "};\n";
		return s;
	}
}
