package agentrouble;

import java.util.*;
import java.io.*;

public class Operacao implements Serializable
{
	public static final boolean debug = true;

	String operador;
	Serializable argumentos;

	public Operacao(String op, Serializable args) {
		operador = op;
		argumentos = args;
	}

	public Serializable argumento() {
		return argumentos;
	}

	public String operador() {
		return operador;
	}

	public String toString() {
		return "OP: {" + operador + "} ARG: {"+argumentos+"}";
	}
}
